



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>深入理解javascript选择器API系列第三篇——h5新增的3种selector方法</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">深入理解javascript选择器API系列第三篇——h5新增的3种selector方法</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-21 23:37:38 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h2>前面的话</h2>
<p>　　尽管DOM作为API已经非常完善了，但是为了实现更多的功能，DOM仍然进行了扩展，其中一个重要的扩展就是对选择器API的扩展。人们对jQuery的称赞，很多是由于jQuery方便的元素选择器。除了前面已经介绍过的<a href="http://www.cnblogs.com/xiaohuochai/p/5797111.html" rel="external nofollow noreferrer">getElementsByClassName()方法</a>外，DOM拓展了querySelectorAll()、querySelector()和matchesSelector()这3种方法，通过CSS选择符查询DOM文档取得元素的引用的功能变成了原生的API，解析和树查询操作在浏览器内部通过编译后的代码来完成，极大地改善了性能。本文将详细介绍html5新增的3种selector方法</p>
<h3>方法</h3>
<p><strong>querySelector()</strong></p>
<p>　　querySelector()方法接收一个CSS选择符，返回与该模式匹配的第一个元素，如果没有找到匹配的元素，返回null。该方法既可用于文档document类型，也可用于元素element类型。关于CSS选择器的详细内容<a href="http://www.cnblogs.com/xiaohuochai/p/4979514.html" rel="external nofollow noreferrer">移步至此</a></p>
<p>　　[注意]IE7-浏览器不支持</p>
<div>
<pre class="prettyprint linenums">&lt;body style="height: 100%;"&gt;<br />
&lt;div class="box" id="box" style="height: 200px;"&gt;<br />
&lt;ul class="list" style="height:100px"&gt;<br />
        &lt;li class="in" style="height: 30px;"&gt;1&lt;/li&gt;<br />
        &lt;li class="in" style="height: 30px;" title="test"&gt;2&lt;/li&gt;<br />
        &lt;li class="in" style="height: 30px;"&gt;3&lt;/li&gt;<br />
    &lt;/ul&gt;<br />
&lt;/div&gt;<br />
&lt;script&gt;<br />
//因为没有.null类名，所以返回null<br />
var oNull = document.querySelector('.null');<br />
console.log(oNull);//null<br />
//通过&lt;body&gt;标签取得元素<br />
var body = document.querySelector("body");<br />
console.log(body.style.height);//100%<br />
//通过id属性取得元素<br />
var oBox = document.querySelector('#box');<br />
console.log(oBox.style.height);//200px<br />
//通过结合元素的类选择器取得元素<br />
var oList = document.querySelector('ul.list');<br />
console.log(oList.style.height);//100px<br />
//通过类名取得元素<br />
var oIn = document.querySelector('.in');<br />
console.log(oIn.innerHTML);//1<br />
//通过属性选择器取得元素<br />
var oTest = body.querySelector('[title="test"]');<br />
console.log(oTest.innerHTML);//2<br />
&lt;/script&gt;<br />
&lt;/body&gt; </pre>
</div>
<p><strong>querySelectorAll()</strong></p>
<p>　　querySelectorAll()接收一个CSS选择符，返回一个类数组对象<a href="http://www.cnblogs.com/xiaohuochai/p/5827389.html#anchor1" rel="external nofollow noreferrer">NodeList</a>的实例。具体来说，返回的值实际上是带有所有属性和方法的NodeList，而其底层实现则类似于一组元素的快照，而非不断对文档进行搜索的动态查询。这样实现可以避免使用NodeList对象通常会引起的大多数性能问题。只要传给querySelectorAll()方法的CSS选择符有效，该方法都会返回一个NodeList对象，而不管找到多少匹配的元素</p>
<p>　　没有匹配元素时，返回空的类数组对象，而不是null</p>
<p>　　[注意]IE7-浏览器不支持</p>
<div>
<pre class="prettyprint linenums">&lt;body style="height: 100%;"&gt;<br />
&lt;div class="box" id="box" style="height: 200px;"&gt;<br />
&lt;ul class="list" style="height:100px"&gt;<br />
        &lt;li class="in" style="height: 30px;"&gt;1&lt;/li&gt;<br />
        &lt;li class="in" style="height: 30px;" title="test"&gt;2&lt;/li&gt;<br />
        &lt;li class="in" style="height: 30px;"&gt;3&lt;/li&gt;<br />
    &lt;/ul&gt;<br />
&lt;/div&gt;<br />
&lt;script&gt;<br />
//返回[]<br />
var oNull = document.querySelectorAll('.null');<br />
console.log(oNull);<br />
//取得body元素<br />
var body = document.querySelectorAll("body")[0];<br />
console.log(body.style.height);//100%<br />
//取得所有class为"in"的元素<br />
var oIn = document.querySelectorAll('.in');<br />
for(var i = 0 ; i &lt; oIn.length; i++){<br />
    console.log(oIn[i].innerHTML);//1,2,3<br />
}<br />
//取得title属性为test的元素<br />
var oTest = body.querySelectorAll('[title="test"]');<br />
console.log(oTest);//[li.in]<br />
&lt;/script&gt;<br />
&lt;/body&gt;</pre>
</div>
<p><strong>matchesSelector()</strong></p>
<p>　　matchesSelector()方法接收一个CSS选择符参数，如果调用元素与该选择符相匹配，返回true；否则返回false</p>
<p>　　[注意]一般地，使用matches()方法来替代matchesSelector()方法</p>
<div>
<pre class="prettyprint linenums">&lt;body id="test"&gt;<br />
&lt;script&gt;<br />
    //Uncaught TypeError: document.body.matchesSelector is not a function<br />
    console.log(document.body.matchesSelector('#test'));<br />
&lt;/script&gt;<br />
&lt;/body&gt;</pre>
</div>
<p>　　由于兼容性问题，现在各个浏览器都只支持加前缀的方法。IE9+浏览器支持msMatchesSelector()方法，firefox支持mozMatchesSelector()方法，safari和chrome支持webkitMatchesSelector()方法。所以兼容写法为:</p>
<div>
<pre class="prettyprint linenums">function matchesSelector(element,selector){<br />
    if(element.matchesSelector){<br />
        return element.matchesSelector(selector);<br />
    }<br />
    if(element.msMatchesSelector){<br />
        return element.msMatchesSelector(selector);<br />
    }<br />
    if(element.mozMatchesSelector){<br />
        return element.mozMatchesSelector(selector);<br />
    }<br />
    if(element.webkitMatchesSelector){<br />
        return element.webkitMatchesSelector(selector);<br />
    }<br />
}</pre>
</div>
<div>
<pre class="prettyprint linenums">&lt;body id="test"&gt;<br />
&lt;script&gt;<br />
console.log(matchesSelector(document.body,'#test'));//true<br />
&lt;/script&gt;<br />
&lt;/body&gt;</pre>
</div>
<h3>非实时</h3>
<p>　　与getElementById()和getElementsByTagName()方法不同，querySelector()和querySelectorAll()方法得到的类数组对象是非动态实时的</p>
<div>
<pre class="prettyprint linenums">&lt;div id="container"&gt;<br />
    &lt;div&gt;1&lt;/div&gt;<br />
    &lt;div&gt;2&lt;/div&gt;<br />
&lt;/div&gt;<br />
&lt;script&gt;<br />
var container = document.getElementById('container');<br />
var divOne = container.querySelector('div:last-child');<br />
var divAll = container.querySelectorAll('div');<br />
console.log(container.children.length);//2<br />
console.log(divOne.innerHTML);//2<br />
console.log(divAll.length);//2

var newDiv = document.createElement('div');<br />
newDiv.innerHTML = 3;<br />
container.appendChild(newDiv);

console.log(container.children.length);//3<br />
//由于querySelector不是实时的，所以其保存的仍然是原来第二个div的值<br />
console.log(divOne.innerHTML);//2<br />
//由于querySelectorAll不是实时的，所以仍然只保存了两个div元素<br />
console.log(divAll.length);//2

console.log(container.querySelector('div:last-child').innerHTML);//3<br />
console.log(container.querySelectorAll('div').length);//3<br />
&lt;/script&gt;</pre>
</div>
<h3>缺陷</h3>
<p>　　selector类方法在元素上调用时，指定的选择器仍然在整个文档中进行匹配，然后过滤出结果集，以便它只包含指定元素的后代元素。这看起来是违反常规的，因为它意味着选择器字符串能包含元素的祖先而不仅仅是所匹配的元素</p>
<div>
<pre class="prettyprint linenums">&lt;div id="container"&gt;<br />
    &lt;div&gt;1&lt;/div&gt;<br />
    &lt;div&gt;2&lt;/div&gt;<br />
&lt;/div&gt;<br />
&lt;script&gt;<br />
var container = document.getElementById('container');<br />
console.log(container.querySelectorAll('div div'));//[div div]<br />
&lt;/script&gt;</pre>
</div>
<p>　　按照正常理解，控制台应该返回空的类数组对象，因为id为container的div元素的子元素中，不存在div元素嵌套的情况</p>
<p>　　但是，该方法实际返回[div div]。这是因为参数中的选择器包含了元素的祖先</p>
<p>　　所以，如果出现后代选择器，为了防止该问题，可以在参数中显式地添加当前元素的选择器</p>
<div>
<pre class="prettyprint linenums">&lt;div id="container"&gt;<br />
    &lt;div&gt;1&lt;/div&gt;<br />
    &lt;div&gt;2&lt;/div&gt;<br />
&lt;/div&gt;<br />
&lt;script&gt;<br />
var container = document.getElementById('container');<br />
console.log(container.querySelectorAll('#container div div'));//[]<br />
console.log(container.querySelectorAll('#container div'));//[div div]<br />
console.log(container.querySelectorAll('div'));//[div div]<br />
&lt;/script&gt;</pre>
</div>
<h2>最后</h2>
<p>　　虽然存在着非实时和参数缺陷的问题，但是瑕不掩瑜，selector类方法的出现极大地简化了查找元素的繁琐操作。而且，它们支持IE8浏览器</p>
<p>　　javascript选择器API系列写完了，欢迎交流</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/5qyyj7gq.html">Equals和ReferenceEquals</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2k1dvq.html">python高级之多进程</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96gnvy8.html">ecshop 给商品随机添加评论</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1yx7x9.html">php 获取时间今天明天昨天时间戳</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlml2k69.html">Bugtags 那些事儿</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1z4vlz9.html">redis学习笔记之pipeline</a>
		</li>
						<li><a href="https://www.batexi.com/a/93x763g9.html">Spring Auto proxy creator example</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1r7gr9.html">elecworks 图框管理器</a>
		</li>
						<li><a href="https://www.batexi.com/a/90v33oj8.html">Linux ulimit 系统资源控制</a>
		</li>
						<li><a href="https://www.batexi.com/a/95x4ylz8.html">Maven 工程下 Spring MVC 站点配置 &lpar;三&rpar; C3P0连接池与&commat;Autowired的应用</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gee4g48.html">Ubuntu 13&period;04&sol;12&period;10安装Oracle 11gR2图文教程&lpar;转&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgppnm8.html">详解Windows Server 2008 R2下安装Oracle 11g</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwj6p7l8.html">Python mac安装mysqlclient的一个bug</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2vm419.html">AMQP close-reason&comma; initiated by Peer&comma; code&equals;406</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gme1vq.html">java&period;lang&period;Enum</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2zjmoq.html">VS诊断工具打开失败</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gyo3mq.html">Django-website 程序案例系列-13 中间件</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjzx769.html">update moudle 调用方式</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2k0xkwq.html">SQL Server 调优系列基础篇 - 子查询运算总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/93p3lgn8.html">javascript中return的作用</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/jqdzov9d.html">【swift】BlockOperation和GCD实用代码块</a>
			</li>
						<li><a href="https://www.batexi.com/a/r93v2r83.html">杂项之python描述符协议</a>
			</li>
						<li><a href="https://www.batexi.com/a/49ggz497.html">Topshelf 支持Mono 扩展Topshelf&period;Linux</a>
			</li>
						<li><a href="https://www.batexi.com/a/4qnwg3qr.html">我正在使用Xamarin的跨平台框架&mdash;Xamarin&period;Android回忆录</a>
			</li>
						<li><a href="https://www.batexi.com/a/0qw40k87.html">&lbrack;异常解决&rsqb; How make ubuntu use Google Search</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8owmp9z.html">img&period;width一直是0的问题--记录（二）</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9p6lzqx.html">Bagging与随机森林算法原理小结</a>
			</li>
						<li><a href="https://www.batexi.com/a/jqdvxvqd.html">C&num; 设置Excel打印选项及打印excel文档</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8o0dx8z.html">读书笔记--SQL必知必会05--高级数据过滤</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9j4vg95.html">以实际的WebGIS例子探讨Nginx的简单配置</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
